# Keyboard Noise Maker

Ever wanted a clicky keyboard but only had a boring quiet one? The solution is here! This is a dedicated hardware "clicker" that you can associate with any USB keyboard. A daemon running on the host computer listens to events from the keyboard and forwards them to an MCU that does the needed clicking.

## Hardware
- Arduino
- Relay module
- Bell(?)

## Software
- USB HID listener attached to a single USB keyboard (tested on Linux)
- output of the listener redirected to Arduino's serial port

## Running

Flash the Arduino code, build the host daemon, run it and redirect it to the Arduino's serial:

```
cd hid_listen
make
sudo ./hid_listen > /dev/ttyUSB0
```

## TODO
- USB device IDs are hard-coded, should be taken as CLI parameters

## Sources
- [USB Raw HID](https://www.pjrc.com/teensy/rawhid.html)

